#include "SDLTimer.h"
#include <assert.h>
#include "Vector.h"

Vector* timerVector = NULL;

void SDLTimer_addTimer( SDLTimer* timer )
{
	if (timerVector == NULL)
		timerVector = Vector_construct();
	
	Vector_add(timerVector, timer); 
}

SDLTimer* SDLTimer_removeTimer( UINT message )
{
	assert(timerVector != NULL);
	
	SDLTimer* found = NULL;
	int i = 0;
	
	for (i = 0; i < Vector_getSize(timerVector); i++)
	{
		found = (SDLTimer*) Vector_get(timerVector, i);
		if (found->message == message)
		{
			Vector_remove(timerVector, i);
			return found;
		}
	}
	return NULL;
}

Uint32 SDLTimer_callback(Uint32 interval, void* param)
{
	SDLTimer* timer = (SDLTimer*) param;


	timer->system->post_message(timer->message, 0);
	
	return interval;
}

